Home Information Classes Download Usage Mail List Requirements Links Tutorial

# BlowHole Class Reference

STK clarinet physical model with one register hole and one tonehole. More...

`#include <BlowHole.h>`

Inheritance diagram for BlowHole:

List of all members.

## Public Member Functions

| BlowHole (MY_FLOAT lowestFrequency)
| Class constructor.
| ~BlowHole ()
| Class destructor.
void | clear ()
| Reset and clear all internal state.
void | setFrequency (MY_FLOAT frequency)
| Set instrument parameters for a particular frequency.
void | setTonehole (MY_FLOAT newValue)
| Set the tonehole state (0.0 = closed, 1.0 = fully open).
void | setVent (MY_FLOAT newValue)
| Set the register hole state (0.0 = closed, 1.0 = fully open).
void | startBlowing (MY_FLOAT amplitude, MY_FLOAT rate)
| Apply breath pressure to instrument with given amplitude and rate of increase.
void | stopBlowing (MY_FLOAT rate)
| Decrease breath pressure with given rate of decrease.
void | noteOn (MY_FLOAT frequency, MY_FLOAT amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (MY_FLOAT amplitude)
| Stop a note with the given amplitude (speed of decay).
MY_FLOAT | tick ()
| Compute one output sample.
void | controlChange (int number, MY_FLOAT value)
| Perform the control change specified by number and value (0.0 - 128.0).

## Detailed Description

STK clarinet physical model with one register hole and one tonehole.

This class is based on the clarinet model, with the addition of a two-port register hole and a three-port dynamic tonehole implementation, as discussed by Scavone and Cook (1998).

In this implementation, the distances between the reed/register hole and tonehole/bell are fixed. As a result, both the tonehole and register hole will have variable influence on the playing frequency, which is dependent on the length of the air column. In addition, the highest playing freqeuency is limited by these fixed lengths.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

Control Change Numbers:

- Reed Stiffness = 2
- Noise Gain = 4
- Tonehole State = 11
- Register State = 1
- Breath Pressure = 128

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 48 of file BlowHole.h.

The documentation for this class was generated from the following file:

- BlowHole.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.